# imported from,
# git 
# https://github.com/brektrou/rtl8821CU/tree/5.8.1
# https://github.com/mbrysa/rtl8821CU

%global	module	8821cu
%global pname rtl%{module}
#%global lname %{pname}-legacy

Name:		dkms-%{pname}
Version:	5.8.1
Release:	%mkrel 3
Source0:	%{pname}-%{version}.tar.xz
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/mbrysa/rtl8821CU
Summary:	dkms package for realtek RTL8811CU/RTL8821CU driver with bt and firmware

# not need since rebase
###Patch0:		rtl8821cu-5.8.1-newrel.patch
###Patch1:		rtl8821cu-kernel-5.8.sup.patch
Patch2:		rtl8821cu-pclos.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	kmod(rtl%{module}.ko) = %{version}
		
Requires(post):		dkms
Requires(preun):	dkms

Obsoletes:	dkms-%{pname} < %{version}-%{release}

%description
Realtek RTL8811CU/RTL8821CU USB wifi adapter driver version 5.4.1 for
Linux 4.4.x up to 5.4.x
The Realtek RTL8821CU-CG is a highly integrated single-chip that supports
1-stream 802.11ac solutions with Multi-user MIMO (Multiple-Input,
Multiple-Output) and Wireless LAN (WLAN) with integrated Bluetooth 2.1/3.0/4.2
USB-multi interface controller.
It combines a WLAN MAC, a 1T1R capable WLAN baseband, and RF in a single chip.
The RTL8821CU-CG provides a complete solution for a high-performance integrated
wireless and Bluetooth device.
Drivers for rtl8811CU and rtl8821CU Wi-Fi chipsets.
This repository is based on soruce code found on a CD shipped
with a rtl8811CU based card.
It's updated to build on newer kernel versions.

Note: This is an USB2 only adapter,
which may have bluetooth support
For specialities on this device read at the end

build/load/function tested with v4.18.7

CDROM emulation
The device exists in various flavours
including cdrom emulation for windows
knowing USB id's doing this trick (after cold boot)

    0x0bda 0x1a2b

you can do a scsi cdrom ejcet with
usb_modeswitch -v 0bda -p 1a2b -K
or
eject $DEVICE

Bluetooth support
named as btcoexist should be provid from rtlwifi-extended,
install the dkms-rtlwifi-extended first

if you would automatic switch into wifi-mode even the dongle is pluged-in,
then add in /etc/udev/rules.d/
90-rtl8821CU.rules
ATTRS{idVendor}=="0bda", ATTRS{idProduct}=="1a2b", RUN+="/usr/sbin/usb_modeswitch -KW -v 0bda -p 1a2b"

%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}/lib/firmware
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a . %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
#%__mv -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/firmware/rtl8821cufw.bin %{buildroot}/lib/firmware/
#%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}
%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME="%{pname}"
BUILT_MODULE_LOCATION="./"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
CLEAN="'make' clean"
DEST_MODULE_LOCATION="/kernel/3rdparty/%{pname}"
AUTOINSTALL="yes"
EOF

%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
if [ -f /etc/NetworkManager/NetworkManager.conf ]; then
randmacad=`grep "wifi.scan-rand-mac-address=no" /etc/NetworkManager/NetworkManager.conf`
fi
if [ "$randmacad" = z ]; then
echo "
[device]
wifi.scan-rand-mac-address=no
" >> /etc/NetworkManager/NetworkManager.conf
fi
/sbin/modprobe %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{pname}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{pname}/ d' /etc/modprobe.preload
fi
## remove module-destdir just if it empty after dkms remove,(user's only deinstall after testing)... ##
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
###%doc LICENSE README.md
%{_usrsrc}/%{pname}-%{version}-%{release}
####/lib/firmware/rtl8821cufw.bin

%changelog

%changelog
* Thu Aug 20 2020 onkelho <oh.quait at gmail.com> - 5.8.1-3pclos2020
- rebuild - rebase source

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 5.8.1-2pclos2020
- rebuild fix kernel-5.6... on updated source

* Mon Feb 17 2020 onkelho <oh.quait at gmail.com> - 5.8.1-1pclos2020
- new ver-rel Realtek on 
- Disable power save
- Enable monitor mode
- Enable VHT

* Mon Feb 17 2020 onkelho <oh.quait at gmail.com> - 5.4.1-4pclos2020
- rebuild - fix working on kernel-5.3.., 5.4.., 5.5...
- Fix FCS on 8821cu #33 from pbeyl/master Latest commit fa09e80 on Jan 16 

* Wed Oct 23 2019 onkelho <oh.quait at gmail.com> - 5.4.1-3pclos2019
- rebuild - fix working on kernel-5.3...and 5.4..

* Mon Jul 15 2019 onkelho <oh.quait at gmail.com> 5.4.1-1pclos2019
- new ver - rel

* Mon Mar 11 2019 onkelho <oh.quait at gmail.com> 5.2.5.3-6pclos2019
- rebuild

* Sat Jan 12 2019 onkelho <oh.quait at gmail.com> 5.2.5.3-5pclos2019
- rebuild --add patch0

* Sat Nov 24 2018 onkelho <oh.quait at gmail.com> 5.2.5.3-3pclos2018
- rebuild

* Thu Nov 22 2018 onkelho <oh.quait at gmail.com> - 5.2.5.3-1pclos2018
- initial build on pclos

